{<skip/>}
{****************************
* (C) 2010 onerobot.org     *
* Demo of xconduit          *
* AppletImage=scope.gif     *
*****************************
v.5 5-4: Uses rts correctly.  Streams to specified location in world array.
v.6 7-11: doesn't use other objects, loads program remotely, new mDbg command, stops cogs correctly
v.7 6: New TBot with new pins, better rts management


XConduit:
  Communication should allow:
  - sending a message and getting it's forced reply
  - streaming data into a shared memory
  - writing data to hub
  - executing commands like reboot, stopcogs, clear
  - commanding the remote bot to write data/stream/send a message
  - terminal emulation 
  Most of the complexity is managed by spin code which manages several arrays:
  - cmdList: communication request are placed here
  - cmdStatus: status for a communication request will be returned here 
  - mailbox: new mail from other bots is placed here
  - info: information from other bots is shared here
  Communication requests can be one of the following:  
  - write: write data to hub
  - send: send message to remote bot's mailbox.  Remote must send a "reply" which is placed in reply buffer 
  - reply: send reply to a "sent" message
  - reboot: reboot the remote bot
  - stopcogs: stop all cogs aside from xconduit cog to prevent hub from changing 
  - stream: continuously stream data from info to other bots'info without acknowledgement
  - addcmd: add a command to the remote bot's list
  - clear: clear command list on the remote bot
  - debug: sends a debug reply consisting of first bytes of hub
  - commands are stored: [mode4,addr4,ptr16,length8]
  Bots can communicate using a "Terminal"
  - Bots need to start a session with a bot and memory for the in/out queues
  - Once it has a session, data to output is added to the outq
  - The driver code will output the whole outq whenever it's not empty
  - Incoming data is added to the inq circular buffer.
  - cmd for cterminal is:[mode4,addr4,ptr16,outtail8]
  - status for cterminal is: [outhead8,inhead8,intail8,_]
  - terminal data is not acknowledged
}
con
  _clkmode      = xtal1 + pll16x
  _xinfreq      = 6_000_000

  
  maxCmds=16
  maxBots=16
  lenInfo=12
  lenMail=10
  lengthQ=4
  retriesAdd=4
  retriesSend=3
  timeoutSend=8_000_000
{ xbeetx    long  |<12
xbeerx    long  |<13
xbeerts   long  |<15}
  TXPIN=|<12  
  RXPIN=|<13
  RTSPIN=|<15
  RSTPIN=|<5
  #0,mAddCmd,mWrite,mSend,mReply,mReboot,mStopCogs,mStream,mTerm,mClear,mDbg
  xRX16=$81
  xTX16=$01
  xTXstatus=$89
  xStartByte=$7e
  {useless info:
  buffer for sending data out is 202 bytes long, cts is de-asserted when only 17 free
  use ap=2 when using escaped characters see pg57

  TODO:
  -test terminal 12blocks
  -test send 12blocks
  -test write 12blocks
  -use longs
  }
  i2cSCL        = 28
  i2cSDA        = 29 
  MCP23008_Addr = %0100_0000  
pub start(_cmdList,_cmdStatus,_mailbox,_rssi,_sender2terminal,_sender2mail,_dptr)
  tcmdList:=_cmdList
  tcmdStatus:=_cmdStatus
  tmailbox:=_mailbox
  tinfo:=_dptr+4
  trssi:=_rssi
  dbgptr:=_dptr
  tsend2term:=_sender2terminal
  tsend2mail:=_sender2mail
  bytefill(tcmdList,0,maxCmds*4)  
  bytefill(tcmdStatus,0,maxCmds*4)
  bytefill(tmailbox,0,maxbots*lenMail)
  bytefill(tsend2term,0,maxbots)
  bytefill(tsend2mail,0,maxbots)
  txiMask:=$ffff_ffff-txMask
  rtsiMask:=$ffff_ffff-rtsMask
  rstMask:=$ffff_ffff-RSTPIN
  bitticks:=clkfreq/115_200
  stoptickst:=bitticks*10
  stopticks:=bitticks*2
  ldelay:=clkfreq/10                  
 
  cognew(@pasmTX,0)
pub receive(sptr,sStart,sLen)
pub stream(sptr,sStart,sLen)
  return addCmd(mstream,0,sStart<<2,sLen<<2)
pub clearCmd(addr)
  {clears the command list on addr}
  return doCmdAck(addr,mClear,0,0)
pub addRemoteCmd(addr,raddr,rmode,rptr,rlen)|t
  {add a command on addr's command list}
  t:=rmode<<28+raddr<<24+rptr<<8+rlen
  return doCmdAck(addr,mAddCmd,@t,4)
pub startTerminal(addr,qptr)|cIdx
  {starts a terminal session with a bot}
  cIdx:=addCmd(mTerm,addr,qptr,0)
  if cIdx==-1
    return false
  long[tcmdStatus][cidx]~   
  long[tsend2Term][addr]:=cIdx
  return cIdx
pub stopTerminal(cIdx)
  waitcnt(cnt+clkfreq/1)
  long[tcmdList][cIdx]~
  { input comes in at inhead.  output goes out at outhead
    - cmd    for cterminal is:[mode4   ,addr4  ,ptr16  ,outtail8]
    - status for cterminal is:[outhead8,intail8,inhead8,_       ]}
pub tx(t,tb)|cmd,outq,ptr,head
  {send a byte over emulated terminal and increment outhead}
  cmd:=long[tcmdList][t]
  ptr:=(cmd>>8) & $ffff
  head:=byte[tcmdStatus+(t<<2)+3]
  
  byte[ptr+head++]:=tb                     
  if head==lengthQ
    head~     
  repeat while head==byte[tcmdList+(t<<2)]
 
  byte[tcmdStatus+(t<<2)+3]:=head          
pub rxavailable(t)|cmd,ptr,head,tail
  {returns true if data available}
  cmd:=long[tcmdList][t]
  ptr:=(cmd>>8) & $ffff+lengthQ
  tail:=byte[tcmdStatus+(t<<2)+2]
  head:=byte[tcmdStatus+(t<<2)+1]
  return head<>tail
pub rx(t)|cmd,ptr,head,tail
  {waits until rxavailable, then returns a byte}
  repeat while not rxavailable(t)
  cmd:=long[tcmdList][t]   
  ptr:=(cmd>>8) & $ffff+lengthQ
  tail:=byte[tcmdStatus+(t<<2)+2]  
  result:=byte[ptr + tail]
  tail+=1
  if tail==lengthq
    tail~
  byte[tcmdStatus+t<<2+2]:=tail
pub gotMail(addr,nptr)
  {See if we've got mail from a bot
    addr:address of bot you'd like to check mail from
    returns address of received mail on success or false}
  if byte[tmailbox][lenMail*addr]
    bytemove(nptr,tmailbox+lenMail*addr,lenMail)
    return true
  return false
pub reply(addr,ptr)
  {Reply to a mail
  Return TRUE on success}
  byte[tmailbox+lenMail*addr]~ 
  return doCmdAck(mReply,addr,ptr,lenMail)
pub send(addr,ptr,rptr)|cIdx,cntr,ts2m
  {Send "mail" to another bot.
    addr:address of bot to send to, 0 sends to all
    ptr:points to data to send
    rptr:points to area where reply will be stored
    Returns TRUE if successful}
  ts2m:=tsend2mail+addr
  if byte[ts2m]==0
    repeat retriesSend
      cIdx:=addCmd(mSend,addr,ptr,lenMail)
      if cIdx> -1
        long[tcmdStatus][cIdx]:=rptr
        byte[ts2m]:=cIdx
        cntr:=cnt      
        repeat while cnt-cntr < timeoutSend
          if (long[tcmdStatus][cIdx] & |<31)     
            long[tcmdList][cIdx]~
            byte[ts2m]~
            return true
        long[tcmdList][cIdx]~          
  byte[ts2m]~
  return false
'med level  
pub doCmdAck(mode,addr,ptr,len)|cIdx,cntr
  {Do command and wait for ack
  used by cStopCogs,cWrite,cReboot,cReply
  cStream doesn't care about ACK
  cSend waits for mReply
  returns TRUE on success}
   
  repeat retriesSend
    cIdx:=addCmd(mode,addr,ptr,len)
    long[tcmdStatus][cIdx]~
    cntr:=cnt
    repeat while cnt-cntr<timeoutSend
      if long[tcmdStatus][cIdx] & $B000_0000      
        long[tcmdList][cIdx]~
        return true
    long[tcmdList][cIdx]~        
  return false        
pub addCmd(mode,addr,ptr,len)|i
  {Add a command to the list.  Returns index of command, or -1 if none available after retrying.}
  repeat retriesAdd
    repeat i from 0 to maxCmds-1
      if long[tcmdList][i]==0  
        long[tcmdList][i]:=mode<<28+addr<<24+ptr<<8+len
        return i
  return -1
  
'low level PASM driver code (spin for now)        
   
dat  
'prog long $d63d0337,$3d03371c,$7e041cd4
{ spin code for:
  dira[pin]~~
  outa[pin]~~
  repeat}   
  org 0
pasmTx              
     
     
     
          or dira,setdira
          or outa,setouta          
      
          
 cmdLoop  mov   tIdxc,#MaxCmds
 txLoop   call  #doRX
          tjnz  stopped,#txLoop 
          djnz  t6,#txLoop
          mov   t6,#$11f
          mov tIdx,tIdxc
          sub tIdx,#1 wz  
          mov   tIdx2,tIdx
          shl   tIdx2,#2   
          mov   t1,tIdx2
          add   t1,tcmdList
          rdlong tCmd,t1 
          cmp   tCmd,#2 wc
  if_nc   call  #txCmd
          djnz  tIdxc,#txLoop     
'****
'mov stopped,#10                             
'call #sdStp
'mov stopped,#0
          jmp   #cmdLoop 
   txCmd                 
 
          mov   tlen,tCmd   
          and   tlen,#255  
          mov   tptr,tCmd
          shr   tptr,#8
          and   tptr,tWord 
          mov   taddr,tCmd
          shr   taddr,#24
          and   taddr,#15 wz  
   if_z   mov   taddr,tword   
          mov   tmode,tCmd                   
          shr   tmode,#28
          and   tmode,#15  wz
          mov   toptions,#0
          mov   tframe,tIdxc
          mov   twrap,#0 
 
  {if mode==mSend or mode==mStream
   
    frame~
    options:=1
    if mode==mSend
      len+=1}
          cmp   tmode,#mSend wz
  if_z    mov   tframe,#0
  if_z    mov   toptions,#1
  if_z    add   tlen,#1
          cmp   tmode,#mStream wz    
  if_z    mov   tframe,#0
  if_z    mov   toptions,#1
  if_z    add   tlen,#1 
          cmp   tmode,#mTerm wz
  if_nz   jmp   #:notTerm        
  {elseif mode==mTerm   output from tail to head
    - cmd    for cterminal is:[mode4   ,addr4  ,ptr16  ,outtail8]
    - status for cterminal is:[outhead8,intail8,inhead8,_       ]}
          mov   tframe,#0   
          mov   toptions,#1 
          mov   ttail,tlen  
          mov   twrap,tptr
          add   twrap,#lengthQ'    wrap:=ptr+lengthQ
          mov   thead,tIdx2
                    
          add   thead,#3         
          add   thead,tcmdStatus
          rdbyte thead,thead
          
         
          
          cmp   thead,ttail wz
   if_z   jmp   #txcmd_ret    
          mov   tlen,thead
          sub  tlen,ttail   wc
   if_c   add  tlen,#lengthQ
   
      
          add   tptr,ttail  
  :notTerm      
          
 
          mov   tbyte,#xStartByte'  txByte(xStartByte)
          call  #transmit
          call  #transmit
          mov   tbyte,tlen
          add   tbyte,#6
          call  #transmit 
          mov   tcrc,#255
          mov   tbyte,#xtx16
          call  #transmitcrc'  txByte(xTX16)
          mov   tbyte,tframe
          call  #transmitcrc
          mov   tbyte,taddr
          shr   tbyte,#8
          call  #transmitcrc
          mov   tbyte,taddr
          call  #transmitcrc'  txByte(addr)
          mov   tbyte,toptions
          call  #transmitcrc
 
          mov   tbyte,tmode
          call  #transmitcrc'    txByte(mode)
          cmp   tmode,#mdbg  wz
   if_z   mov   tbyte,tptr
   if_z   call  #transmitcrc  
   if_z   call  #transmitcrc
   if_z   mov   tbyte,tcrc
   if_z   call  #transmit
   if_z   jmp   #txcmd_ret     
          cmp   tmode,#msend wz
   if_z   mov   tbyte,tidx
   if_z   call  #transmitcrc
   if_z   sub   tlen,#1'    len-=1
          cmp   tmode,#mstream wz
   if_z   mov   tbyte,tptr
   if_z   call  #transmitcrc
   if_z   add   tptr,tinfo 
   if_z   sub   tlen,#1'    len-=1
          
          mov   t1,tlen
 :repLen  rdbyte tbyte,tptr 
          
          call  #transmitcrc
          add   tptr,#1
          cmp   tptr,twrap wz
    if_z  sub   tptr,#lengthq
          djnz  t1,#:repLen
          mov   tbyte,tcrc
          call  #transmit
          mov   t1,tidx2          
          cmp   tmode,#mStream wz
   if_z   add   t1,tcmdstatus
   if_z   rdlong  t2,t1                    
   if_z   add   t2,#1
   if_z   wrlong  t2,t1'    cmdStatus[cIdx]++ 
   if_z   jmp   #txcmd_ret
          cmp   tmode,#mTerm wz
   if_z   add   t1,tcmdlist
   if_z   wrbyte thead,t1'in terminal mode:byte[@cmdList+(cIdx<<2)]:=head 
   if_z   jmp   #txcmd_ret
          add   t1,tcmdList
          mov   t2,#1
          wrlong t2,t1
txcmd_ret ret                 
'********rx
'Receive data from device:start,len2,x81,source2,rssi,options,data

dorx        
          and     outa,rtsimask 
          mov     rxcnt,stopticks
          add     rxcnt,cnt   
          mov     t1,#0   
         
          call    #rxByte
          cmp     rxData,#xstartByte wz
   if_z   jmp     #hStart
   rxend  or      outa,rtsmask   
          call    #rxByte
          cmp     rxData,#xstartByte wz
   if_nz  jmp     #dorx_ret 
          and     outa,rtsimask 
          add     rxcnt,stopticks
   hStart call    #rxByte 
          call    #rxByte
          mov     tlen,rxData
          sub     tlen,#6
          call    #rxByte
          cmp     rxData,#xTXstatus wz
    
    if_nz jmp     #:notStat
   

          call    #rxByte
          mov     tFrame,rxData
          sub     tFrame,#1
          mov     t2,tFrame
          shl     t2,#2
          add     t2,tcmdStatus
          add     t2,#3
          rdbyte  t3,t2 
          call    #rxByte
          cmp     rxData,#0 wz  
   if_z   or      t3,#64 
          or      t3,#128
          tjnz    stopped,#:skipw 
          wrbyte  t3,t2           
:skipw    jmp     #rxend'
  
 :notStat
             
          cmp     rxData,#xRX16 wz   
  if_nz   jmp     #rxend        
   

          call    #rxByte'      rxByte sender msb, always <256, so ignore      
          call    #rxByte
          
          mov     tSender,rxData
          mov     t2,trssi
          add     t2,tSender
          call    #rxByte
          tjnz    stopped,#:norssi
          wrbyte  rxData,t2'  rssi[sender]:=rxByte store latest signal for that sender
 :norssi  call    #rxByte
          call    #rxByte     
          mov     tMode,rxData
          add     rxData,#:domode
          nop

          jmp     rxData
          
:domode   jmp     #rAddCmd
          jmp     #rWrite
          jmp     #rSend
          jmp     #rReply
          jmp     #rReboot
          jmp     #rStopCogs
          jmp     #rStream
          jmp     #rTerm
          jmp     #rClear
          jmp     #rDbg
         
  rr      mov   tbyte,tMode
          jmp   #rxend
  rDbg   
          call  #sdStp
          jmp   #dorx_ret
sdStp          
          or    outa,rtsmask   
          mov   tcmd,stopped
          shl   tcmd,#8
          shl   tsender,#24
          add   tcmd,tsender
          add   tcmd,dbgEcho
          call  #txCmd
sdStp_ret ret
          
  rClear  mov   t2,#MaxCmds
          mov   t3,tcmdList
          mov   t4,#0          
  :clear  wrlong  t4,t3 
          add   t3,#4
          djnz  t2,#:clear
          jmp   #rxend  
         
 rTerm          
           
   
   
      
          add   tsender,tsend2term
          rdbyte  tsender,tsender 
          shl   tsender,#2
          
          mov   tptr,tsender
          add   tptr,tcmdList
          rdlong tptr,tptr
          shr   tptr,#8
          and   tptr,tword
          add   tptr,#lengthQ'ptr:=(cmdList[tsender] >>8) & $ffff_ffff + lengthQ
          mov   t2,tsender
          
          add   t2,#1
          add   t2,tcmdStatus
          rdbyte t2,t2
          add   t2,tptr
          mov   t3,tptr
          add   t3,#lengthQ
  :rep    call  #rxbyte
          wrbyte  rxdata,t2
          add   t2,#1
          cmp   t2,t3 wz
     if_z mov   t2,tptr'i:=ptr                 
          djnz  tlen,#:rep
          add   tsender,#1
          add   tsender,tcmdStatus
          sub   t2,tptr
          wrbyte  t2,tsender'  byte[@cmdStatus+tsender<<2+1]:=i-ptr
          mov   tbyte,t2
          jmp   #rxend
  rAddCmd call  #rxLong 
          mov   t2,#maxCmds
          mov   t3,tcmdList
   :addc  rdlong tCmd,t3 wz
    if_z  wrlong t5,t3
          add   t3,#4
    if_nz djnz  t2,#rAddCmd
          jmp   #rxend
  rReboot and   outa,rstmask  
          or    outa,rtsmask   
          mov   t3,thirty2k  
          mov   stopped,#0
          nop
          or    outa,setouta    
  :crc    rdbyte t2,t3           
          add   stopped,t2
          djnz  t3,#:crc
          and   stopped,#255 
          mov   t3,cnt
          add   t3,ldelay
          waitcnt t3,ldelay
          call  #sdStp           
          mov   t3,cnt           
          add   t3,ldelay
          waitcnt t3,ldelay
          tjnz  stopped,#rxend
          cogid t3
          coginit interpreter 
          cogstop t3
          jmp   #rxend
rStopCogs
          or    outa,rtsmask
          mov   stopped,#1 
          call  #sdstp  
          cogid t3
          mov   t1,#0
          mov   t2,#8  
   :reb   cmp   t1,t3 wz 
   if_nz  cogstop t1  
          lockclr t1 
          lockret t1
          add   t1,#1   
          djnz  t2,#:reb   
          mov   t3,thirty2k
          sub   t3,#3  
  :clearm wrlong t2,t3
          sub   t3,#3
          djnz  t3,#:clearm
          jmp   #rxend 
   rWrite call  #rxByte
          mov   tptr,rxData
          shl   tptr,#8
          call  #rxByte
          add   tptr,rxData'ptr:=rxByte<<8+rxByte
          sub   tlen,#2'          length-=2
:wData    call  #rxByte       
          wrbyte rxData,tptr' byte[ptr++]:=rxByte
          add   tptr,#1
          djnz  tlen,#:wData
          jmp   #rxEnd       
  rSend   mov   tptr,tMailbox
          mov   t2,tSender wz  
:mm if_nz add   tptr,#lenMail
          djnz  t2,#:mm
          call  #rxByte
          wrbyte rxData,tptr
          sub   tlen,#1'          length-=1
          jmp   #rData
  rReply  add   tSender,tSend2Mail
          rdbyte rxData,tSender
          shl   rxData,#2 
          add   rxData,tcmdStatus
          mov   tframe,rxData
          rdlong tptr,rxData 
          sub   tlen,#1'        length-=1          
          jmp   #rData
  rStream
          mov   tptr,tInfo
          call  #rxByte 
          add   tptr,rxData  
          sub   tlen,#1  
rData     call  #rxByte
          tjnz  stopped,#:nowr
          wrbyte rxData,tptr' byte[ptr++]:=rxByte
:nowr     add   tptr,#1
          djnz  tlen,#rData'repeat length                
          cmp   tmode,#mReply wz
  if_z    wrlong highbit,tframe
          
         
'Parameter = 1), data will not be sent out the DO Buffer as long as RTS (pin 16) is de-asserted.
'data not sent as long as rts is low
          jmp   #rxend 
 dorx_ret  ret          
'******************* read an int into t4
  rxLong  mov     t4,#0
          mov     t5,#4
 :loop    call    #rxByte
          add     t4,rxData
          shl     t4,#8
          djnz    t5,#:loop
rxLong_ret ret        
'******************* read a byte into rxdata.  if none found, goes to startnotmatched
rxbyte
 wstart   test    rxmask,ina      wc
if_nc     jmp     #gotStart
          mov     t0,rxcnt
          sub     t0,cnt wc          
   if_nc  jmp     #wstart    
          mov     rxdata,#0
          jmp     #rxbyte_ret    
gotstart  mov     rxcnt,cnt 
          mov     t0,bitticks
          shr     t0,#1    
          add     rxcnt,t0 
          mov     rxbits,#9            
:bit      waitcnt rxcnt,bitticks       
          test    rxmask,ina      wc   
          rcr     rxdata,#1
          djnz    rxbits,#:bit      
          shr     rxdata,#32-8 
          waitcnt rxcnt,stopticks
         
         
         
          add     t1,#1
rxbyte_ret ret
rxbits long 0
rxcnt long 0
rxdata long 0

    
'************ send out tbyte and dec crc
transmitcrc
          sub  tcrc,tbyte  
          call #transmit
transmitcrc_ret ret
'************ send out tbyte, leaving it 0
transmit                                                
                        
                        mov     txcnt,bitticks
                        add     txcnt,cnt
                        and     outa,tximask 
                        mov     t0,#8
:bit                                                       
                        shr     tByte,#1       wc 
                        waitcnt txcnt,bitticks     
                        muxc    outa,txmask  
                        djnz    t0,#:bit
                        waitcnt txcnt,stoptickst 
                        or      outa,txmask   
                       
                        waitcnt txcnt,#0
           transmit_ret ret   
                        
                  
                        
dbgEcho                 long  mDbg<<28|0<<24|2
tidxc                 long 0
thirty2k                long 32767   
hsec                    long    8_000_000                        
asec                    long    800_000  
ldelay long $1000_0000
rxmask                  long    RXPIN
txmask                  long    TXPIN
rtsmask                long    RTSPIN
setdira                 long   RTSPIN | TXPIN | RSTPIN
setouta                 long   TXPIN | RSTPIN
rtsimask                long   0
bitticks                long    0
stopticks               long    0
stoptickst              long    0
tximask                 long    0
rstmask                 long    0
mcmd               long 0'mstream<<28|1<<24|0<<8|12
txcnt                 long    0
tbyte                 long    0    
tIdx2                 long    0
trssi                 long    0
tinfo                 long    0
myinfo                long    0
tmailbox              long    0
tcmdlist                 long    0
tsend2term          long 0
tsend2mail              long 0
tcmdstatus                 long    0
tcmd                 long    0
tmode                 long    0
taddr                 long    0
tptr                 long    0
tsender            long 0
tframe                 long    0
tlen                 long    0
tcrc                 long    0
toptions                 long    0
thead                 long    0
ttail                 long    0
twrap                 long    0
tidx                 long    0
tword                 long     $ffff
dbgptr                  long 0
interpreter             long    ($0001 << 18) | ($F004 << 2) | %0000
highbit                 long $f000_0000
stopped                 long 0
t6 long 100
t0 res 1
t1 res 1
t2 res 1
t3 res 1
t4 res 1
t5 res 1
t7 res 1
