/*
Modified by Lauren
version 0.3

Any suggestions are welcome.
E-mail: Lauran.pan@gmail.com

Editor     : Lauren from DFRobot
Date       : 06.01.2012

==

* Have the back light under control.
* Update the library and sketch to compatible with IDE V1.0 and earlier

*/

#ifndef LCD4884_h
#define LCD4884_h

#if defined(ARDUINO) && ARDUINO >= 100
#include "Arduino.h"
#else
#include "WProgram.h"
#endif

/* SPI Interface --- (
using d12 to dc
a4 to rst
d13 to lcdclk
lcdd7 to din
*/

#define SPI_CS  -1  //Chip Select,Slave Transmit Enable(active low,Master Output)
#define LCD_BL  -1//Backlit control (Arduino DIO Pin 7)


//display mode -- normal / highlight
#define MENU_NORMAL 0
#define MENU_HIGHLIGHT 1
#define OFF 0
#define ON 1


class LCD4884
{
private:
 unsigned char LCD_dc,LCD_RST,SPI_SCK,SPI_MOSI;
public:
LCD4884();
void LCD_init(unsigned char rst,unsigned char dc,unsigned char din,unsigned char clk);
void backlight(unsigned char dat);
void print(unsigned char X,unsigned char Y,char *s);     
void print(unsigned char X,unsigned char Y,int s);     
void LCD_Bitmap(char my_array[],int x,int y,int len);
void LCD_write_byte(unsigned char dat, unsigned char dat_type);
void LCD_draw_bmp_pixel(unsigned char X,unsigned char Y,unsigned char *map,unsigned char Pix_x,unsigned char Pix_y);
void LCD_write_string(unsigned char X,unsigned char Y,char *s, char mode);      
void LCD_write_char_big (unsigned char X,unsigned char Y, unsigned char ch, char mode);
unsigned char LCD_write_char(unsigned char c, char mode);
void LCD_set_XY(unsigned char X, unsigned char Y);
void LCD_clear(void);
};

              
#endif   // 
