#include "sserial.h"
void SSerial::init(int baud,int rx,int tx){
	bitl=1000000L/baud;
	rxp=rx;
	txp=tx;
	digitalWrite(txp,HIGH);
	delay(10);
}
void SSerial::out(int b){
	long tick=micros()+bitl;
	int s=(1<<9)+(b<<1)+0;
	for(int m=0;m<10;m++){
		delayMicroseconds(tick-micros());
		if((s & 1)==1) 
			digitalWrite(txp,HIGH);
		else
			digitalWrite(txp,LOW);			
		s>>=1;
		tick+=bitl;
	}
}
void SSerial::str(char* sptr){	
	while(*sptr != 0x00){
		out(*sptr++);	
		delay(10);
		}
}
char* SSerial::in(int msec) {
	int n,b,i;
	long tick,now;
	i=0;	
	now=millis()+msec;
	while((digitalRead(rxp)==0) && (now-millis()>0)) 
		delayMicroseconds(bitl/8);  //wait for high
	while(now-millis()>0){
		if(digitalRead(rxp)==0) { //in start bit
			b=0;
			tick=micros()+bitl;  //delay to middle of first data
			for(n=0;n<8;n++) {
				delayMicroseconds(tick-micros()); //delay between bits
				if(digitalRead(rxp)==1) 
					b=(b>>1)+128;
				else
					b=b>>1;
				tick+=bitl;
			}
			delayMicroseconds(tick-micros());  //delay to stop bit
			buff[i++]=b & 255;									
		}
		else
			delayMicroseconds(bitl/8);
	}
	buff[i]=0;
	return buff;
}  