#ifndef VPSerial_h
#define VPSerial_h
#include <inttypes.h>
#include "Stream.h"



class _VPSerial 
{
  public:
	void sendISR();
    void receiveISR();
    void init(int baud);
    
  private:
	virtual void set(volatile uint8_t *ubrrh, volatile uint8_t *ubrrl,
      volatile uint8_t *ucsra, volatile uint8_t *ucsrb,
      volatile uint8_t *ucsrc, volatile uint8_t *udr,
      uint8_t rxen, uint8_t txen, uint8_t rxcie, uint8_t udrie, uint8_t u2x);
	volatile uint8_t *_ubrrh;
    volatile uint8_t *_ubrrl;
    volatile uint8_t *_ucsra;
    volatile uint8_t *_ucsrb;
    volatile uint8_t *_ucsrc;
    volatile uint8_t *_udr;
    uint8_t _rxen;
    uint8_t _txen;
    uint8_t _rxcie;
    uint8_t _udrie;
    uint8_t _u2x;	  
};
class _VPTerm
{
  public:
	virtual int available(void);
    virtual int peek(void);
    virtual int read(void);
    virtual void flush(void);
	virtual void str(String s);
    virtual void str(char* StringPtr);
    virtual void write(char);
	virtual void dec(int x);
	virtual void col(int c);
	virtual void strnum(String s,int x);
	virtual void strnum(char* StringPtr,int x);
	virtual void pos(int x,int y);    
};
extern _VPSerial _vp;
#define SERIAL_8N1 0x06
#endif

