#ifndef OR_scara_h
#define OR_scara_h
#include <inttypes.h>
class _OR_scara
{
  public:	
    void begin(); 
	void home(int x,int y,int z);		
	void isr();
	void steps();
	void steps(int dx,int dy,int dz);
	void move(int x,int y,int z);
	void target(int x,int y,int z);//move to an exact cartesian	
	void speed(int x); //how fast next target will be 
  private:
	void getaxis(int x,int y,double *elbow,double *shoulder);
    int _x,_y,_z; //position of head
	int _el,_sh; //zero pos
	int _speed; //config
	static const uint8_t _STEPN=3; //number of steppers
	int _steps[_STEPN],_done[_STEPN],_dir[_STEPN],_max[_STEPN]; //current step,when travel done, dir pin,max pin
	uint8_t _next[_STEPN],_bit[_STEPN];  //time for next toggle, bit pin
	volatile uint8_t *_out[_STEPN]; //address for toggling
	uint8_t _event; //time till next toggle
	static const int _l1=5000,_l2=5000,_l3=2500,_l4=2500; // cartesian to scara config
};
#endif	