CON
 _clkmode        = xtal1 + pll16x
 _clkfreq        = 96_000_000
 clk8192=_clkfreq/8192
 bits=11
 biasSamples=500
pub start(_a,_b)
  pina:=_a
  pinb:=_b
  asm_dira:=|<_b
  mic~
  cognew(@sampleMIC, @mic)
  
  waitcnt(cnt+clkfreq/2)'wait for ac coupling to stabilize
pub readmic
  return mic
pub readfreq
  result:=_clkfreq/freq
pub readamp
  result:=amp
dat 'adapted from Chip's "microphone_to_headphones"
              org
sampleMic     mov       dira,asm_dira                   'make pins 8 (ADC) and 0 (DAC) outputs
              movs      ctra,pina                         'POS W/FEEDBACK mode for CTRA
              movd      ctra,pinb
              movi      ctra,#%01001_000
              mov       frqa,#1
              mov       asm_cnt,cnt                     'prepare for WAITCNT loop
              add       asm_cnt,asm_cycles
              mov       amp,#0
:loop1        mov       avg,navg

              mov       ptr,par
              add       ptr,#4
              wrlong    tamp,ptr              
              add       ptr,#4
              wrlong    tfreq,ptr
              mov       tamp,#0
              mov       tfreq,#0                             
:loop         waitcnt   asm_cnt,asm_cycles              'wait for next CNT value (timing is determinant after WAITCNT)
              mov       asm_sample,phsa                 'capture PHSA and get difference
              sub       asm_sample,asm_old
              add       asm_old,asm_sample  

              mov       acxv0,acxv1               'acxv0=acxv1  AC COUPLING,  HP  100Hz
              mov       acxv1,asm_sample
              shl       acxv1,#5                  ' shift up/down
              mov       acyv0,acyv1               'acyv0=acyv1
              mov       acyv1,#0                  ' now MAC   Gain=32
              add       acyv1,acxv1               'acyv1=axxv1-acxv0 +0.93acyv0
              subs      acyv1,acxv0
              add       acyv1,acyv0               ' +1
              mov       fitemp,acyv0
              sar       fitemp,#4                 ' -0.06
              sub       acyv1,fitemp              ' AC result
              mov       fitemp,acyv1
              sar       fitemp,#5     
              wrlong    fitemp,par                  'write to main memory
 'set c if neg, set inNeg
              cmps      fitemp,#0 wc   'fitemp <0
       if_c   mov       inNeg,#1
       if_c   jmp       #:eloop         
 'c not set, so positive.  if inNeg=0 loop because not transition
              min       amp,fitemp   
              tjz       inNeg,#:eloop
              
              mov       inNeg,#0
              cmp       amp,#25 wc  'amp<0
        if_c  mov       lastX,cnt      
        if_c  jmp       #:eloop  
              mov       freq,cnt
              sub       freq,lastX
              mov       lastX,cnt
              'freq=cnt-lastx, lastx=cnt              
              min       tamp,amp
              min       tfreq,freq
              mov       amp,#1
  :eloop      djnz      avg,#:loop                           
              jmp       #:loop1                         'wait for next sample period
              
asm_cycles    long      |< bits - 1                     'sample time
pina          long      0
pinb          long      0
asm_dira      long      0    'output mask
mic           long      0
amp           long      0
freq          long      0
navg          long      10000
asm_sample    long      |< bits - 2
acyv1         long      0
acxv1         long      0
tamp          long      0
tfreq         long      0
avg           long      0
lastX         res       1
inNeg         res       1 'state if in neg
ptr           res       1
tmp           res       1
asm_cnt       res       1
asm_old       res       1
acxv0         res       1
acyv0         res       1
fitemp        res       1
                                                                                                   